;ͻ
; Modul     lauf7.asm (anderer Name als C-Programm wegen Object-File)     
;                                                                         
; Compiler  Turbo Assembler 3.0 / Borland C++ 3.1                         
;                                                                         
; Datum     Karlsruhe, den 04.07.94                                       
;                                                                         
; Gruppe                                                                  
;                                                                         
; Autor     Hartung Wilstermann & Ingo Gabriel                            
;Ķ
; Inhalt    Ein/Ausgabe ber 8255-Baustein                                
;ͼ
;ͻ
; Programmkopf                                                             
;ͼ
	P486			;Prozessortyp angeben, 486 Code zulassen
	.MODEL USE16 SMALL	;Speichermodell auswaehlen
;ͻ
; Konstanendeklaration                                                     
;ͼ
	MSDOS		equ 21h	;MS-DOS Interruptnummer

;Ŀ
;  Konstanten fuer den I/O-Baustein 8255                                  
;
	PortA		equ 300h;Adresse Port A
	PortB		equ 301h;Adresse Port B
	CntlReg		equ 303h;Adresse Kontrollregister
	LslReset	equ 9Bh

;ͻ
; Variablendeklaration mit Anfangswert                                     
;ͼ
		DATASEG
	EXTRN _wartezeit:word
;ͻ
; Programmdeklaration                                                      
;ͼ
		CODESEG

	PUBLIC _Lauflicht

;͸
; Unterprogramme                                                           
;;
;Ŀ
; I/O-Baustein 8255 initialisieren                                         
;
InitPorts proc           ;8255-Baustein initialisieren


	ret		;Ruecksprung
InitPorts endp		;Unterprogramm Ende


;Ŀ
; Port A,B und C zuruecksetzen (alle auf Eingang)                          
;
ResetPorts proc         ;8255-Baustein zuruecksetzen


	ret		;Ruecksprung
ResetPorts endp		;Unterprogramm Ende
;Ŀ
; Port B einlesen                                                          
;
ReadPortB proc          ;Liest Port B und uebergibt ihn ueber Stack an main


	ret		;Ruecksprung
ReadPortB endp		;Unterprogramm Ende	
;Ŀ
; Port A ausgeben                                                          
;
WritePortA proc         ;Uebergebene Parameter auf Port A ausgeben


	ret		;Ruecksprung
WritePortA endp		;Unterprogramm Ende


;͸
; "Hauptprogramm" wird als Unterprogramm vom C-Modul aus aufgerufen        
;;
_Lauflicht proc
	push    bp		;alle Register sichern (wichtig!)
	push    sp
	push    ds
	push    ss
	call    InitPorts	;I/O-Baustein 8255 initialisieren
	call    InitTimer       ;Timer initialisieren

	call 	ResetPorts	;Zuruecksetzen des 8255
	pop     ss
	pop     ds
	pop     sp
	pop     bp
	ret
_Lauflicht endp

end